import logging
import os
import unittest
import datetime
from datetime import date, timedelta, datetime
from pypinyin import pinyin
from FakeSlot import FakeSlotGold, FakeSlotMoney, Slot
from slot import Slot
from Decoder import PeriodDecoder

class TestSlotDecoderTool(unittest.TestCase):
    """Test Util Tool"""

    @classmethod
    def setUp(self) -> None:
        today = date.today() - timedelta(days=1)
        offset = (today.weekday() - 2) % 7
        last_wednesday = today - timedelta(days=offset)
        self.lastweek_3 = last_wednesday
        pass

    def test_SlotDate(self):
        a = Slot(label="DATE", text="今天")
        self.assertEqual(a.value, datetime.today().strftime("%Y-%m-%d"))
        a = Slot(label="DATE", text="昨晚")
        self.assertEqual(a.value, (datetime.today()-timedelta(days=1)).strftime("%Y-%m-%d"))
        a = Slot(label="DATE", text="上星期")
        self.assertEqual(a.value,(datetime.today()-timedelta(days=7)).strftime("%Y-%m-%d"))
        a = Slot(label="DATE", text="上星期三")
        #self.assertEqual(a.value,datetime.strptime(self.lastweek_3.strftime("%Y-%m-%d"), "%Y-%m-%d"))
        a = Slot(label="DATE", text="二零一九年十一月十五日")
        self.assertEqual(a.value,datetime(year=2019, month=11, day=15).strftime("%Y-%m-%d"))
        a = Slot(label="DATE", text="2019年11月15日")
        self.assertEqual(a.value, datetime(year=2019, month=11, day=15).strftime("%Y-%m-%d"))
        a = Slot(label="DATE", text="11月15日")
        self.assertEqual(a.value, datetime(year=2019, month=11, day=15).strftime("%Y-%m-%d"))
        a = Slot(label="DATE", text="3.13日")
        self.assertEqual(a.value, datetime(year=2019, month=3, day=13).strftime("%Y-%m-%d"))
        a = Slot(label="DATE", text="2019.6.1")
        self.assertEqual(a.value, datetime(year=2019, month=6, day=1).strftime("%Y-%m-%d"))
        a = Slot(label="DATE", text="2019")
        self.assertEqual(a.value, datetime(year=2019, month=1, day=1).strftime("%Y-%m-%d"))
        a = Slot(label="DATE", text="29号")
        self.assertEqual(a.value, datetime(year=datetime.now().year, month=datetime.now().month, day=29).strftime("%Y-%m-%d"))
        a = Slot(label="DATE", text="20190530")
        self.assertEqual(a.value, datetime(year=2019,month=5, day=30).strftime("%Y-%m-%d"))
        a = Slot(label="DATE", text="2019_5-3-")
        self.assertEqual(a.value, datetime(year=2019,month=5, day=3).strftime("%Y-%m-%d"))
        a = Slot(label="DATE", text="2019.6")
        self.assertEqual(a.value, datetime(year=2019,month=6, day=datetime.now().day).strftime("%Y-%m-%d"))
        a = Slot(label="DATE", text="6，1")
        self.assertEqual(a.value, datetime(year=datetime.now().year,month=6, day=1).strftime("%Y-%m-%d"))
        a = Slot(label="DATE", text="219-06-01")
        self.assertEqual(a.value, datetime(year=219, month=6, day=1).strftime("%Y-%m-%d"))

    def test_SlotMoney(self):
        a = Slot(label="MON", text="3万")
        self.assertEqual(30000.0, a.value)
        a = Slot(label="MON", text="2.6万")
        self.assertEqual(26000.0, a.value)
        a = Slot(label="MON", text="300多")
        self.assertEqual(300.0, a.value)
        a = Slot(label="MON", text="14万左右")
        self.assertEqual(140000.0, a.value)
        a = Slot(label="MON", text="6w多")
        self.assertEqual(60000.0, a.value)
        a = Slot(label="MON", text="9千块钱")
        self.assertEqual(9000.0, a.value)
        a = Slot(label="MON", text="42万块钱")
        self.assertEqual(420000.0, a.value)
        a = Slot(label="MON", text="48万多块")
        self.assertEqual(480000.0, a.value)
        a = Slot(label="MON", text="十几万")
        self.assertEqual(100000.0, a.value)
        a = Slot(label="MON", text="几十万")
        self.assertEqual(100000.0, a.value)
        a = Slot(label="MON", text="两百多万")
        self.assertEqual(2000000.0, a.value)
        a = Slot(label="MON", text="5毛钱")
        self.assertEqual(0.5, a.value)
        a = Slot(label="MON", text="4.13")
        self.assertEqual(4.13, a.value)
        a = Slot(label="MON", text="4.03")
        self.assertEqual(4.03, a.value)
        a = Slot(label="MON", text="50.01元")
        self.assertEqual(50.01, a.value)
        a = Slot(label="MON", text="1000+")
        self.assertEqual(1000, a.value)
        a = Slot(label="MON", text="上万")
        self.assertEqual(10000, a.value)
        a = Slot(label="MON", text="四点三十三")
        self.assertEqual(4.33, a.value)
        a = Slot(label="MON", text="三点十三")
        self.assertEqual(3.13, a.value)
        a = Slot(label="MON", text="十三点十三")
        self.assertEqual(13.13, a.value)

        # GOLD
        a = Slot(label="MON", text="3万多币")
        self.assertEqual(30000.0, a.value)
        a = Slot(label="MON", text="2.6万左右金币")
        self.assertEqual(26000.0, a.value)
        a = Slot(label="MON", text="300金币")
        self.assertEqual(300.0, a.value)
        a = Slot(label="MON", text="14万金币")
        self.assertEqual(140000.0, a.value)
        a = Slot(label="MON", text="6w多金币")
        self.assertEqual(60000.0, a.value)
        a = Slot(label="MON", text="982金币")
        self.assertEqual(982.0, a.value)



    def test_SlotCHA(self):

        a = Slot(label="CHA", text="支付")
        self.assertEqual("支付宝", a.value)
        a = Slot(label="CHA", text="尊享")
        self.assertEqual("尊享闪付", a.value)
        a = Slot(label="CHA", text="闪付")
        self.assertEqual("尊享闪付", a.value)
        a = Slot(label="CHA", text="云闪付")
        self.assertEqual("云闪付", a.value)
        a = Slot(label="CHA", text="银行扫码")
        self.assertEqual("银行", a.value)
        a = Slot(label="CHA", text="花贝")
        self.assertEqual("花呗", a.value)
        a = Slot(label="CHA", text="支付宝定额")
        self.assertEqual("支付宝定额", a.value)
        a = Slot(label="CHA", text="微信充值")
        self.assertEqual("微信", a.value)
        try:
            a = Slot(label="CHA", text="云顶")
        except ValueError:
            pass



    def test_SlotTIME(self):
        a = Slot(label="TIME", text="10:30")
        self.assertEqual(datetime.now().replace(hour=10, minute=30).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="10.30")
        self.assertEqual(datetime.now().replace(hour=10, minute=30).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="十點三十分")
        self.assertEqual(datetime.now().replace(hour=10, minute=30).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="十點三十一分")
        self.assertEqual(datetime.now().replace(hour=10, minute=31).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="十點三十一")
        self.assertEqual(datetime.now().replace(hour=10, minute=31).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="晚上十點")
        self.assertEqual(datetime.now().replace(hour=22, minute=00).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="下午三點")
        self.assertEqual(datetime.now().replace(hour=15, minute=00).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="三點半")
        self.assertEqual(datetime.now().replace(hour=3, minute=30).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="十三點半")
        self.assertEqual(datetime.now().replace(hour=13, minute=30).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="二十三點半")
        self.assertEqual(datetime.now().replace(hour=23, minute=30).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="23:10:23")
        self.assertEqual(datetime.now().replace(hour=23, minute=10).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="十九点五十一分")
        self.assertEqual(datetime.now().replace(hour=19, minute=51).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="05:36")
        self.assertEqual(datetime.now().replace(hour=5, minute=36).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="晚上十三.十三")
        self.assertEqual(datetime.now().replace(hour=13, minute=13).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="08：00分")
        self.assertEqual(datetime.now().replace(hour=8, minute=0).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="07点29")
        self.assertEqual(datetime.now().replace(hour=7, minute=29).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="下午13.25")
        self.assertEqual(datetime.now().replace(hour=13, minute=25).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="五十分")
        self.assertEqual(datetime.now().replace(minute=50).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="凌晨01：52")
        self.assertEqual(datetime.now().replace(hour=1, minute=52).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="一点20几分钟")
        self.assertEqual(datetime.now().replace(hour=1, minute=20).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="晚上八点多")
        self.assertEqual(datetime.now().replace(hour=20, minute=00).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="八点零一分四十五秒")
        self.assertEqual(datetime.now().replace(hour=8, minute=1).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="八点零一分四十五秒左右")
        self.assertEqual(datetime.now().replace(hour=8, minute=1).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="昨晚上21:13")  # ignore date
        self.assertEqual(datetime.now().replace(hour=21, minute=13).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="下午两点50")  # ignore date
        self.assertEqual(datetime.now().replace(hour=14, minute=50).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="前半小时")
        self.assertEqual((datetime.now()-timedelta(minutes=30)).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="凌晨45分")
        self.assertEqual(datetime.now().replace(hour=0, minute=45).strftime("%H:%M"), a.value)

        # per
        a = Slot(label="TIME", text="早上")
        self.assertEqual(datetime.now().replace(hour=9, minute=00).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="下午")
        self.assertEqual(datetime.now().replace(hour=15, minute=00).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="中午")
        self.assertEqual(datetime.now().replace(hour=12, minute=00).strftime("%H:%M"), a.value)
        a = Slot(label="TIME", text="晚上")
        self.assertEqual(datetime.now().replace(hour=18, minute=00).strftime("%H:%M"), a.value)



    def test_SlotPER(self):
        format_method = PeriodDecoder.output_format
        a = Slot(label="PER", text="三天")
        self.assertEqual(format_method(timedelta(days=3)), a.value)
        a = Slot(label="PER", text="半天")
        self.assertEqual(format_method(timedelta(hours=12)), a.value)
        a = Slot(label="PER", text="二個小時")
        self.assertEqual(format_method(timedelta(hours=2)), a.value)
        a = Slot(label="PER", text="3日")
        self.assertEqual(format_method(timedelta(days=3)), a.value)
        a = Slot(label="PER", text="3星期")
        self.assertEqual(format_method(timedelta(days=21)), a.value)
        a = Slot(label="PER", text="3個月兩天二小時")
        self.assertEqual(format_method(timedelta(days=92,hours=2)), a.value)
        a = Slot(label="PER", text="3個月兩天二小時三十秒")  # ignore sec
        self.assertEqual(format_method(timedelta(days=92, hours=2)), a.value)
        a = Slot(label="PER", text="3個月兩天二小時三十分鐘")
        self.assertEqual(format_method(timedelta(days=92, hours=2, minutes=30)), a.value)
        a = Slot(label="PER", text="十多分钟")
        self.assertEqual(format_method(timedelta(minutes=10)), a.value)
        a = Slot(label="PER", text="10分钟左右")
        self.assertEqual(format_method(timedelta(minutes=10)), a.value)
        a = Slot(label="PER", text="26小时")
        self.assertEqual(format_method(timedelta(hours=26)), a.value)
        a = Slot(label="PER", text="6个半小时")
        self.assertEqual(format_method(timedelta(hours=6.5)), a.value)
        a = Slot(label="PER", text="五六分鐘")
        self.assertEqual(format_method(timedelta(minutes=6)), a.value)
        a = Slot(label="PER", text="好几个月")
        self.assertEqual(format_method(timedelta(days=30)), a.value)
        a = Slot(label="PER", text="好几天")
        self.assertEqual(format_method(timedelta(days=1)), a.value)
        a = Slot(label="PER", text="20几天")
        self.assertEqual(format_method(timedelta(days=20)), a.value)
        a = Slot(label="PER", text="好多天")
        self.assertEqual(format_method(timedelta(days=1)), a.value)
        a = Slot(label="PER", text="20多天")
        self.assertEqual(format_method(timedelta(days=20)), a.value)
        a = Slot(label="PER", text="几个月")
        self.assertEqual(format_method(timedelta(days=30)), a.value)
        a = Slot(label="PER", text="几个小时")
        self.assertEqual(format_method(timedelta(hours=1)), a.value)
        a = Slot(label="PER", text="几天")
        self.assertEqual(format_method(timedelta(days=1)), a.value)
        a = Slot(label="PER", text="几年")
        self.assertEqual(format_method(timedelta(days=360)), a.value)

